// ---------------------------------------------------------------------
/*
 * Copyright 2010 Kyoto University and Honda Motor Co.,Ltd.
 * All rights reserved.
 * HARK was developed by researchers in Okuno Laboratory
 * at the Kyoto University and Honda Research Institute Japan Co.,Ltd.
 */
// ---------------------------------------------------------------------
#ifndef	HarkFileIOByMatrix_NH_h_defined
#define	HarkFileIOByMatrix_NH_h_defined
// ---------------------------------------------------------------------
#include "../config.h"


#include "BF_Matrix.h"

#include <vector>

#ifdef ENABLE_HARKIO3
#else
#include "HarkFileIO.h"
#endif

class CHarkFileIOByMatrix
{
public:
	CHarkFileIOByMatrix();
	~CHarkFileIOByMatrix();
	
	// tft@C̃I[v(cFilenameɊJĂꍇ̓X[)
	bool OpenTFfile(const char* cFilename, const char* cFileType);

	// tft@C̍ăI[v
	bool ReopenTFfile(const char* cFilename, const char* cFileType);
	
	// tft@C̃N[Y
	bool CloseTFfile();
	
	// t@Cǂݍ
	bool ReadHeader(const char* cFilename, const char* cFileType,
					long *plFs,
					long *plNFFT,
					long *plNSrc,
					long *plNMic);
	
	// TFf[^Ǎ
	bool ReadTFData(const char* cFilename, 
					float thresh,
					BF::TransformFunctionDatabase &sDatabase);
	
	// SPf[^Ǎ
	bool ReadWData(const char* cFilename, 
					BF::Database &sDatabase);

	// SPf[^
	bool WriteWData(const char* cFilename, 
					long lFs,
					long lNFFT,
					BF::Database sDatabase);

	
	// o[
	char*	m_pcTFfilename;	///< TFt@C
	char*	m_pcFileType;
#ifdef ENABLE_HARKIO3
	harkio_TransferFunction	*m_ptf;	///< TFt@C|C^
#else
	CHarkFileIO	m_ctf;
#endif
	
private:
	void _CalcNeighbors(std::vector<BF::SourceLocation> sourceLocations, float thresh, std::vector<std::vector<int> > &viNbrs);
};
#endif
